'' PropCOMM  By Jeff Ledger
'' A simple terminal program which communicates to the PC by way of the prop-plug (30,31)
''
'' PropCOMM is set for 9600,N,8,1


CON

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
   
   keyPins   = 26 
   bspKey    = $C8
   escape    = $CB
   backspace = 8
   fReturn   = 13
   fLinefeed = 10
   fEof      = -1
      
   maxstack  = 20                      ' Maximum stack depth
   linelen   = 256                     ' Maximum input line length
   quote     = 34                      ' Double quote
   caseBit   = !32                     ' Uppercase/Lowercase bit
   CtrlAltDelete = $6C9
   nt = 1234

   serXmit   = 30                      ' Serial Transmit
   serRecv   = 31                      ' Serial Receive
   

var
   long sp, tp, eop, nextlineloc, rv, curlineno
   byte tline[linelen]

OBJ

  text  : "ymtv_text"
  key   : "comboKeyboard"             ' Keyboard Driver
  ser   : "FullDuplexSerial"          ' Full Duplex Serial Controller
       
PUB start | i, a, b, TimeCnt

  key.start(keyPins)                            ' Start keyboard driver
  text.start(12)                                ' Start terminal screen   
  ser.start(serRecv,serXmit,%0000,9600)         ' Control link via prop-plug
  
  text.str(string($C,5,"    PropCOMM V1.0b:   By Jeff Ledger    ",$C,13))
  text.str(string($C,8))

  text.str(string(" [F1] Reset Terminal Window",13))
  text.str(string(" [F2] Set Terminal to Half Duplex",13))
  text.str(string(" [F3] Set Terminal to Full Duplex",13))
  text.str(string(" 9600,N,8,1: Terminal Ready.",13,":"))

  repeat
    terminal

PRI terminal | local,remote,duplex

   duplex := 0
   repeat
      local := key.key
      if local <> 0
         if duplex == 1 
            text.out(local)
         'text.dec(local) 'Used to troubleshoot local input
         if local == 208
            local := 13
            text.out($00)
            text.str(string($C,5,"    PropCOMM V1.0b:   By Jeff Ledger    ",$C,13))
            text.str(string($C,8))

         if local == 209
            duplex := 1
            local := 13
            text.str(string("HALF DUPLEX",13))
            
         if local == 210
            duplex := 0
            local := 13
            text.str(string("FULL DUPLEX",13))
            
         ser.tx(local)
         if local == fReturn
           ser.tx(10) ' may not be needed for standard BBS use
           ser.tx(13) ' may not be needed for standard BBS use
         if local == bspKey
           ser.str(string(8," ",8,8))
             if duplex == 1  'Display Backspace in Half Duplex mode
                 text.str(string(backspace," ",backspace,backspace))

      remote := ser.rxtime(20)
      if remote == 8
         text.str(string(backspace," ",backspace))
         remote := 0
         
      if remote > 10
           'text.dec(remote) 'Used to troubleshoot remote input
           text.out(remote)
